      1: <?php
      2:
      3: namespace Thelia\Model\om;
      4:
      5: use \BasePeer;
      6: use \Criteria;
      7: use \PDO;
      8: use \PDOStatement;
      9: use \Propel;
     10: use \PropelException;
     11: use \PropelPDO;
     12: use Thelia\Model\CustomerPeer;
     13: use Thelia\Model\CustomerTitle;
     14: use Thelia\Model\CustomerTitleI18nPeer;
     15: use Thelia\Model\CustomerTitlePeer;
     16: use Thelia\Model\map\CustomerTitleTableMap;
     17:
     18: /**
     19:  * Base static class for performing query and update operations on the 'customer_title' table.
     20:  *
     21:  *
     22:  *
     23:  * @package propel.generator.Thelia.Model.om
     24:  */
     25: abstract class BaseCustomerTitlePeer
     26: {
     27:
     28:     /** the default database name for this class */
     29:     const DATABASE_NAME = 'thelia';
     30:
     31:     /** the table name for this class */
     32:     const TABLE_NAME = 'customer_title';
     33:
     34:     /** the related Propel class for this table */
     35:     const OM_CLASS = 'Thelia\\Model\\CustomerTitle';
     36:
     37:     /** the related TableMap class for this table */
     38:     const TM_CLASS = 'CustomerTitleTableMap';
     39:
     40:     /** The total number of columns. */
     41:     const NUM_COLUMNS = 5;
     42:
     43:     /** The number of lazy-loaded columns. */
     44:     const NUM_LAZY_LOAD_COLUMNS = 0;
     45:
     46:     /** The number of columns to hydrate (NUM_COLUMNS - NUM_LAZY_LOAD_COLUMNS) */
     47:     const NUM_HYDRATE_COLUMNS = 5;
     48:
     49:     /** the column name for the id field */
     50:     const ID = 'customer_title.id';
     51:
     52:     /** the column name for the by_default field */
     53:     const BY_DEFAULT = 'customer_title.by_default';
     54:
     55:     /** the column name for the position field */
     56:     const POSITION = 'customer_title.position';
     57:
     58:     /** the column name for the created_at field */
     59:     const CREATED_AT = 'customer_title.created_at';
     60:
     61:     /** the column name for the updated_at field */
     62:     const UPDATED_AT = 'customer_title.updated_at';
     63:
     64:     /** The default string format for model objects of the related table **/
     65:     const DEFAULT_STRING_FORMAT = 'YAML';
     66:
     67:     /**
     68:      * An identiy map to hold any loaded instances of CustomerTitle objects.
     69:      * This must be public so that other peer classes can access this when hydrating from JOIN
     70:      * queries.
     71:      * @var        array CustomerTitle[]
     72:      */
     73:     public static $instances = array();
     74:
     75:
     76:     // i18n behavior
     77:
     78:     /**
     79:      * The default locale to use for translations
     80:      * @var        string
     81:      */
     82:     const DEFAULT_LOCALE = 'en_US';
     83:     /**
     84:      * holds an array of fieldnames
     85:      *
     86:      * first dimension keys are the type constants
     87:      * e.g. CustomerTitlePeer::$fieldNames[CustomerTitlePeer::TYPE_PHPNAME][0] = 'Id'
     88:      */
     89:     protected static $fieldNames = array (
     90:         BasePeer::TYPE_PHPNAME => array ('Id', 'ByDefault', 'Position', 'CreatedAt', 'UpdatedAt', ),
     91:         BasePeer::TYPE_STUDLYPHPNAME => array ('id', 'byDefault', 'position', 'createdAt', 'updatedAt', ),
     92:         BasePeer::TYPE_COLNAME => array (CustomerTitlePeer::ID, CustomerTitlePeer::BY_DEFAULT, CustomerTitlePeer::POSITION, CustomerTitlePeer::CREATED_AT, CustomerTitlePeer::UPDATED_AT, ),
     93:         BasePeer::TYPE_RAW_COLNAME => array ('ID', 'BY_DEFAULT', 'POSITION', 'CREATED_AT', 'UPDATED_AT', ),
     94:         BasePeer::TYPE_FIELDNAME => array ('id', 'by_default', 'position', 'created_at', 'updated_at', ),
     95:         BasePeer::TYPE_NUM => array (0, 1, 2, 3, 4, )
     96:     );
     97:
     98:     /**
     99:      * holds an array of keys for quick access to the fieldnames array
    100:      *
    101:      * first dimension keys are the type constants
    102:      * e.g. CustomerTitlePeer::$fieldNames[BasePeer::TYPE_PHPNAME]['Id'] = 0
    103:      */
    104:     protected static $fieldKeys = array (
    105:         BasePeer::TYPE_PHPNAME => array ('Id' => 0, 'ByDefault' => 1, 'Position' => 2, 'CreatedAt' => 3, 'UpdatedAt' => 4, ),
    106:         BasePeer::TYPE_STUDLYPHPNAME => array ('id' => 0, 'byDefault' => 1, 'position' => 2, 'createdAt' => 3, 'updatedAt' => 4, ),
    107:         BasePeer::TYPE_COLNAME => array (CustomerTitlePeer::ID => 0, CustomerTitlePeer::BY_DEFAULT => 1, CustomerTitlePeer::POSITION => 2, CustomerTitlePeer::CREATED_AT => 3, CustomerTitlePeer::UPDATED_AT => 4, ),
    108:         BasePeer::TYPE_RAW_COLNAME => array ('ID' => 0, 'BY_DEFAULT' => 1, 'POSITION' => 2, 'CREATED_AT' => 3, 'UPDATED_AT' => 4, ),
    109:         BasePeer::TYPE_FIELDNAME => array ('id' => 0, 'by_default' => 1, 'position' => 2, 'created_at' => 3, 'updated_at' => 4, ),
    110:         BasePeer::TYPE_NUM => array (0, 1, 2, 3, 4, )
    111:     );
    112:
    113:     /**
    114:      * Translates a fieldname to another type
    115:      *
    116:      * @param      string $name field name
    117:      * @param      string $fromType One of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
    118:      *                         BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM
    119:      * @param      string $toType   One of the class type constants
    120:      * @return string          translated name of the field.
    121:      * @throws PropelException - if the specified name could not be found in the fieldname mappings.
    122:      */
    123:     public static function translateFieldName($name, $fromType, $toType)
    124:     {
    125:         $toNames = CustomerTitlePeer::getFieldNames($toType);
    126:         $key = isset(CustomerTitlePeer::$fieldKeys[$fromType][$name]) ? CustomerTitlePeer::$fieldKeys[$fromType][$name] : null;
    127:         if ($key === null) {
    128:             throw new PropelException("'$name' could not be found in the field names of type '$fromType'. These are: " . print_r(CustomerTitlePeer::$fieldKeys[$fromType], true));
    129:         }
    130:
    131:         return $toNames[$key];
    132:     }
    133:
    134:     /**
    135:      * Returns an array of field names.
    136:      *
    137:      * @param      string $type The type of fieldnames to return:
    138:      *                      One of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
    139:      *                      BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM
    140:      * @return array           A list of field names
    141:      * @throws PropelException - if the type is not valid.
    142:      */
    143:     public static function getFieldNames($type = BasePeer::TYPE_PHPNAME)
    144:     {
    145:         if (!array_key_exists($type, CustomerTitlePeer::$fieldNames)) {
    146:             throw new PropelException('Method getFieldNames() expects the parameter $type to be one of the class constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME, BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM. ' . $type . ' was given.');
    147:         }
    148:
    149:         return CustomerTitlePeer::$fieldNames[$type];
    150:     }
    151:
    152:     /**
    153:      * Convenience method which changes table.column to alias.column.
    154:      *
    155:      * Using this method you can maintain SQL abstraction while using column aliases.
    156:      * <code>
    157:      *      $c->addAlias("alias1", TablePeer::TABLE_NAME);
    158:      *      $c->addJoin(TablePeer::alias("alias1", TablePeer::PRIMARY_KEY_COLUMN), TablePeer::PRIMARY_KEY_COLUMN);
    159:      * </code>
    160:      * @param      string $alias The alias for the current table.
    161:      * @param      string $column The column name for current table. (i.e. CustomerTitlePeer::COLUMN_NAME).
    162:      * @return string
    163:      */
    164:     public static function alias($alias, $column)
    165:     {
    166:         return str_replace(CustomerTitlePeer::TABLE_NAME.'.', $alias.'.', $column);
    167:     }
    168:
    169:     /**
    170:      * Add all the columns needed to create a new object.
    171:      *
    172:      * Note: any columns that were marked with lazyLoad="true" in the
    173:      * XML schema will not be added to the select list and only loaded
    174:      * on demand.
    175:      *
    176:      * @param      Criteria $criteria object containing the columns to add.
    177:      * @param      string   $alias    optional table alias
    178:      * @throws PropelException Any exceptions caught during processing will be
    179:      *       rethrown wrapped into a PropelException.
    180:      */
    181:     public static function addSelectColumns(Criteria $criteria, $alias = null)
    182:     {
    183:         if (null === $alias) {
    184:             $criteria->addSelectColumn(CustomerTitlePeer::ID);
    185:             $criteria->addSelectColumn(CustomerTitlePeer::BY_DEFAULT);
    186:             $criteria->addSelectColumn(CustomerTitlePeer::POSITION);
    187:             $criteria->addSelectColumn(CustomerTitlePeer::CREATED_AT);
    188:             $criteria->addSelectColumn(CustomerTitlePeer::UPDATED_AT);
    189:         } else {
    190:             $criteria->addSelectColumn($alias . '.id');
    191:             $criteria->addSelectColumn($alias . '.by_default');
    192:             $criteria->addSelectColumn($alias . '.position');
    193:             $criteria->addSelectColumn($alias . '.created_at');
    194:             $criteria->addSelectColumn($alias . '.updated_at');
    195:         }
    196:     }
    197:
    198:     /**
    199:      * Returns the number of rows matching criteria.
    200:      *
    201:      * @param      Criteria $criteria
    202:      * @param      boolean $distinct Whether to select only distinct columns; deprecated: use Criteria->setDistinct() instead.
    203:      * @param      PropelPDO $con
    204:      * @return int Number of matching rows.
    205:      */
    206:     public static function doCount(Criteria $criteria, $distinct = false, PropelPDO $con = null)
    207:     {
    208:         // we may modify criteria, so copy it first
    209:         $criteria = clone $criteria;
    210:
    211:         // We need to set the primary table name, since in the case that there are no WHERE columns
    212:         // it will be impossible for the BasePeer::createSelectSql() method to determine which
    213:         // tables go into the FROM clause.
    214:         $criteria->setPrimaryTableName(CustomerTitlePeer::TABLE_NAME);
    215:
    216:         if ($distinct && !in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
    217:             $criteria->setDistinct();
    218:         }
    219:
    220:         if (!$criteria->hasSelectClause()) {
    221:             CustomerTitlePeer::addSelectColumns($criteria);
    222:         }
    223:
    224:         $criteria->clearOrderByColumns(); // ORDER BY won't ever affect the count
    225:         $criteria->setDbName(CustomerTitlePeer::DATABASE_NAME); // Set the correct dbName
    226:
    227:         if ($con === null) {
    228:             $con = Propel::getConnection(CustomerTitlePeer::DATABASE_NAME, Propel::CONNECTION_READ);
    229:         }
    230:         // BasePeer returns a PDOStatement
    231:         $stmt = BasePeer::doCount($criteria, $con);
    232:
    233:         if ($row = $stmt->fetch(PDO::FETCH_NUM)) {
    234:             $count = (int) $row[0];
    235:         } else {
    236:             $count = 0; // no rows returned; we infer that means 0 matches.
    237:         }
    238:         $stmt->closeCursor();
    239:
    240:         return $count;
    241:     }
    242:     /**
    243:      * Selects one object from the DB.
    244:      *
    245:      * @param      Criteria $criteria object used to create the SELECT statement.
    246:      * @param      PropelPDO $con
    247:      * @return                 CustomerTitle
    248:      * @throws PropelException Any exceptions caught during processing will be
    249:      *       rethrown wrapped into a PropelException.
    250:      */
    251:     public static function doSelectOne(Criteria $criteria, PropelPDO $con = null)
    252:     {
    253:         $critcopy = clone $criteria;
    254:         $critcopy->setLimit(1);
    255:         $objects = CustomerTitlePeer::doSelect($critcopy, $con);
    256:         if ($objects) {
    257:             return $objects[0];
    258:         }
    259:
    260:         return null;
    261:     }
    262:     /**
    263:      * Selects several row from the DB.
    264:      *
    265:      * @param      Criteria $criteria The Criteria object used to build the SELECT statement.
    266:      * @param      PropelPDO $con
    267:      * @return array           Array of selected Objects
    268:      * @throws PropelException Any exceptions caught during processing will be
    269:      *       rethrown wrapped into a PropelException.
    270:      */
    271:     public static function doSelect(Criteria $criteria, PropelPDO $con = null)
    272:     {
    273:         return CustomerTitlePeer::populateObjects(CustomerTitlePeer::doSelectStmt($criteria, $con));
    274:     }
    275:     /**
    276:      * Prepares the Criteria object and uses the parent doSelect() method to execute a PDOStatement.
    277:      *
    278:      * Use this method directly if you want to work with an executed statement directly (for example
    279:      * to perform your own object hydration).
    280:      *
    281:      * @param      Criteria $criteria The Criteria object used to build the SELECT statement.
    282:      * @param      PropelPDO $con The connection to use
    283:      * @throws PropelException Any exceptions caught during processing will be
    284:      *       rethrown wrapped into a PropelException.
    285:      * @return PDOStatement The executed PDOStatement object.
    286:      * @see        BasePeer::doSelect()
    287:      */
    288:     public static function doSelectStmt(Criteria $criteria, PropelPDO $con = null)
    289:     {
    290:         if ($con === null) {
    291:             $con = Propel::getConnection(CustomerTitlePeer::DATABASE_NAME, Propel::CONNECTION_READ);
    292:         }
    293:
    294:         if (!$criteria->hasSelectClause()) {
    295:             $criteria = clone $criteria;
    296:             CustomerTitlePeer::addSelectColumns($criteria);
    297:         }
    298:
    299:         // Set the correct dbName
    300:         $criteria->setDbName(CustomerTitlePeer::DATABASE_NAME);
    301:
    302:         // BasePeer returns a PDOStatement
    303:         return BasePeer::doSelect($criteria, $con);
    304:     }
    305:     /**
    306:      * Adds an object to the instance pool.
    307:      *
    308:      * Propel keeps cached copies of objects in an instance pool when they are retrieved
    309:      * from the database.  In some cases -- especially when you override doSelect*()
    310:      * methods in your stub classes -- you may need to explicitly add objects
    311:      * to the cache in order to ensure that the same objects are always returned by doSelect*()
    312:      * and retrieveByPK*() calls.
    313:      *
    314:      * @param      CustomerTitle $obj A CustomerTitle object.
    315:      * @param      string $key (optional) key to use for instance map (for performance boost if key was already calculated externally).
    316:      */
    317:     public static function addInstanceToPool($obj, $key = null)
    318:     {
    319:         if (Propel::isInstancePoolingEnabled()) {
    320:             if ($key === null) {
    321:                 $key = (string) $obj->getId();
    322:             } // if key === null
    323:             CustomerTitlePeer::$instances[$key] = $obj;
    324:         }
    325:     }
    326:
    327:     /**
    328:      * Removes an object from the instance pool.
    329:      *
    330:      * Propel keeps cached copies of objects in an instance pool when they are retrieved
    331:      * from the database.  In some cases -- especially when you override doDelete
    332:      * methods in your stub classes -- you may need to explicitly remove objects
    333:      * from the cache in order to prevent returning objects that no longer exist.
    334:      *
    335:      * @param      mixed $value A CustomerTitle object or a primary key value.
    336:      *
    337:      * @return void
    338:      * @throws PropelException - if the value is invalid.
    339:      */
    340:     public static function removeInstanceFromPool($value)
    341:     {
    342:         if (Propel::isInstancePoolingEnabled() && $value !== null) {
    343:             if (is_object($value) && $value instanceof CustomerTitle) {
    344:                 $key = (string) $value->getId();
    345:             } elseif (is_scalar($value)) {
    346:                 // assume we've been passed a primary key
    347:                 $key = (string) $value;
    348:             } else {
    349:                 $e = new PropelException("Invalid value passed to removeInstanceFromPool().  Expected primary key or CustomerTitle object; got " . (is_object($value) ? get_class($value) . ' object.' : var_export($value,true)));
    350:                 throw $e;
    351:             }
    352:
    353:             unset(CustomerTitlePeer::$instances[$key]);
    354:         }
    355:     } // removeInstanceFromPool()
    356:
    357:     /**
    358:      * Retrieves a string version of the primary key from the DB resultset row that can be used to uniquely identify a row in this table.
    359:      *
    360:      * For tables with a single-column primary key, that simple pkey value will be returned.  For tables with
    361:      * a multi-column primary key, a serialize()d version of the primary key will be returned.
    362:      *
    363:      * @param      string $key The key (@see getPrimaryKeyHash()) for this instance.
    364:      * @return   CustomerTitle Found object or null if 1) no instance exists for specified key or 2) instance pooling has been disabled.
    365:      * @see        getPrimaryKeyHash()
    366:      */
    367:     public static function getInstanceFromPool($key)
    368:     {
    369:         if (Propel::isInstancePoolingEnabled()) {
    370:             if (isset(CustomerTitlePeer::$instances[$key])) {
    371:                 return CustomerTitlePeer::$instances[$key];
    372:             }
    373:         }
    374:
    375:         return null; // just to be explicit
    376:     }
    377:
    378:     /**
    379:      * Clear the instance pool.
    380:      *
    381:      * @return void
    382:      */
    383:     public static function clearInstancePool($and_clear_all_references = false)
    384:     {
    385:       if ($and_clear_all_references)
    386:       {
    387:         foreach (CustomerTitlePeer::$instances as $instance)
    388:         {
    389:           $instance->clearAllReferences(true);
    390:         }
    391:       }
    392:         CustomerTitlePeer::$instances = array();
    393:     }
    394:
    395:     /**
    396:      * Method to invalidate the instance pool of all tables related to customer_title
    397:      * by a foreign key with ON DELETE CASCADE
    398:      */
    399:     public static function clearRelatedInstancePool()
    400:     {
    401:         // Invalidate objects in CustomerPeer instance pool,
    402:         // since one or more of them may be deleted by ON DELETE CASCADE/SETNULL rule.
    403:         CustomerPeer::clearInstancePool();
    404:         // Invalidate objects in CustomerTitleI18nPeer instance pool,
    405:         // since one or more of them may be deleted by ON DELETE CASCADE/SETNULL rule.
    406:         CustomerTitleI18nPeer::clearInstancePool();
    407:     }
    408:
    409:     /**
    410:      * Retrieves a string version of the primary key from the DB resultset row that can be used to uniquely identify a row in this table.
    411:      *
    412:      * For tables with a single-column primary key, that simple pkey value will be returned.  For tables with
    413:      * a multi-column primary key, a serialize()d version of the primary key will be returned.
    414:      *
    415:      * @param      array $row PropelPDO resultset row.
    416:      * @param      int $startcol The 0-based offset for reading from the resultset row.
    417:      * @return string A string version of PK or null if the components of primary key in result array are all null.
    418:      */
    419:     public static function getPrimaryKeyHashFromRow($row, $startcol = 0)
    420:     {
    421:         // If the PK cannot be derived from the row, return null.
    422:         if ($row[$startcol] === null) {
    423:             return null;
    424:         }
    425:
    426:         return (string) $row[$startcol];
    427:     }
    428:
    429:     /**
    430:      * Retrieves the primary key from the DB resultset row
    431:      * For tables with a single-column primary key, that simple pkey value will be returned.  For tables with
    432:      * a multi-column primary key, an array of the primary key columns will be returned.
    433:      *
    434:      * @param      array $row PropelPDO resultset row.
    435:      * @param      int $startcol The 0-based offset for reading from the resultset row.
    436:      * @return mixed The primary key of the row
    437:      */
    438:     public static function getPrimaryKeyFromRow($row, $startcol = 0)
    439:     {
    440:
    441:         return (int) $row[$startcol];
    442:     }
    443:
    444:     /**
    445:      * The returned array will contain objects of the default type or
    446:      * objects that inherit from the default.
    447:      *
    448:      * @throws PropelException Any exceptions caught during processing will be
    449:      *       rethrown wrapped into a PropelException.
    450:      */
    451:     public static function populateObjects(PDOStatement $stmt)
    452:     {
    453:         $results = array();
    454:
    455:         // set the class once to avoid overhead in the loop
    456:         $cls = CustomerTitlePeer::getOMClass();
    457:         // populate the object(s)
    458:         while ($row = $stmt->fetch(PDO::FETCH_NUM)) {
    459:             $key = CustomerTitlePeer::getPrimaryKeyHashFromRow($row, 0);
    460:             if (null !== ($obj = CustomerTitlePeer::getInstanceFromPool($key))) {
    461:                 // We no longer rehydrate the object, since this can cause data loss.
    462:                 // See http://www.propelorm.org/ticket/509
    463:                 // $obj->hydrate($row, 0, true); // rehydrate
    464:                 $results[] = $obj;
    465:             } else {
    466:                 $obj = new $cls();
    467:                 $obj->hydrate($row);
    468:                 $results[] = $obj;
    469:                 CustomerTitlePeer::addInstanceToPool($obj, $key);
    470:             } // if key exists
    471:         }
    472:         $stmt->closeCursor();
    473:
    474:         return $results;
    475:     }
    476:     /**
    477:      * Populates an object of the default type or an object that inherit from the default.
    478:      *
    479:      * @param      array $row PropelPDO resultset row.
    480:      * @param      int $startcol The 0-based offset for reading from the resultset row.
    481:      * @throws PropelException Any exceptions caught during processing will be
    482:      *       rethrown wrapped into a PropelException.
    483:      * @return array (CustomerTitle object, last column rank)
    484:      */
    485:     public static function populateObject($row, $startcol = 0)
    486:     {
    487:         $key = CustomerTitlePeer::getPrimaryKeyHashFromRow($row, $startcol);
    488:         if (null !== ($obj = CustomerTitlePeer::getInstanceFromPool($key))) {
    489:             // We no longer rehydrate the object, since this can cause data loss.
    490:             // See http://www.propelorm.org/ticket/509
    491:             // $obj->hydrate($row, $startcol, true); // rehydrate
    492:             $col = $startcol + CustomerTitlePeer::NUM_HYDRATE_COLUMNS;
    493:         } else {
    494:             $cls = CustomerTitlePeer::OM_CLASS;
    495:             $obj = new $cls();
    496:             $col = $obj->hydrate($row, $startcol);
    497:             CustomerTitlePeer::addInstanceToPool($obj, $key);
    498:         }
    499:
    500:         return array($obj, $col);
    501:     }
    502:
    503:     /**
    504:      * Returns the TableMap related to this peer.
    505:      * This method is not needed for general use but a specific application could have a need.
    506:      * @return TableMap
    507:      * @throws PropelException Any exceptions caught during processing will be
    508:      *       rethrown wrapped into a PropelException.
    509:      */
    510:     public static function getTableMap()
    511:     {
    512:         return Propel::getDatabaseMap(CustomerTitlePeer::DATABASE_NAME)->getTable(CustomerTitlePeer::TABLE_NAME);
    513:     }
    514:
    515:     /**
    516:      * Add a TableMap instance to the database for this peer class.
    517:      */
    518:     public static function buildTableMap()
    519:     {
    520:       $dbMap = Propel::getDatabaseMap(BaseCustomerTitlePeer::DATABASE_NAME);
    521:       if (!$dbMap->hasTable(BaseCustomerTitlePeer::TABLE_NAME)) {
    522:         $dbMap->addTableObject(new CustomerTitleTableMap());
    523:       }
    524:     }
    525:
    526:     /**
    527:      * The class that the Peer will make instances of.
    528:      *
    529:      *
    530:      * @return string ClassName
    531:      */
    532:     public static function getOMClass($row = 0, $colnum = 0)
    533:     {
    534:         return CustomerTitlePeer::OM_CLASS;
    535:     }
    536:
    537:     /**
    538:      * Performs an INSERT on the database, given a CustomerTitle or Criteria object.
    539:      *
    540:      * @param      mixed $values Criteria or CustomerTitle object containing data that is used to create the INSERT statement.
    541:      * @param      PropelPDO $con the PropelPDO connection to use
    542:      * @return mixed           The new primary key.
    543:      * @throws PropelException Any exceptions caught during processing will be
    544:      *       rethrown wrapped into a PropelException.
    545:      */
    546:     public static function doInsert($values, PropelPDO $con = null)
    547:     {
    548:         if ($con === null) {
    549:             $con = Propel::getConnection(CustomerTitlePeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
    550:         }
    551:
    552:         if ($values instanceof Criteria) {
    553:             $criteria = clone $values; // rename for clarity
    554:         } else {
    555:             $criteria = $values->buildCriteria(); // build Criteria from CustomerTitle object
    556:         }
    557:
    558:         if ($criteria->containsKey(CustomerTitlePeer::ID) && $criteria->keyContainsValue(CustomerTitlePeer::ID) ) {
    559:             throw new PropelException('Cannot insert a value for auto-increment primary key ('.CustomerTitlePeer::ID.')');
    560:         }
    561:
    562:
    563:         // Set the correct dbName
    564:         $criteria->setDbName(CustomerTitlePeer::DATABASE_NAME);
    565:
    566:         try {
    567:             // use transaction because $criteria could contain info
    568:             // for more than one table (I guess, conceivably)
    569:             $con->beginTransaction();
    570:             $pk = BasePeer::doInsert($criteria, $con);
    571:             $con->commit();
    572:         } catch (PropelException $e) {
    573:             $con->rollBack();
    574:             throw $e;
    575:         }
    576:
    577:         return $pk;
    578:     }
    579:
    580:     /**
    581:      * Performs an UPDATE on the database, given a CustomerTitle or Criteria object.
    582:      *
    583:      * @param      mixed $values Criteria or CustomerTitle object containing data that is used to create the UPDATE statement.
    584:      * @param      PropelPDO $con The connection to use (specify PropelPDO connection object to exert more control over transactions).
    585:      * @return int             The number of affected rows (if supported by underlying database driver).
    586:      * @throws PropelException Any exceptions caught during processing will be
    587:      *       rethrown wrapped into a PropelException.
    588:      */
    589:     public static function doUpdate($values, PropelPDO $con = null)
    590:     {
    591:         if ($con === null) {
    592:             $con = Propel::getConnection(CustomerTitlePeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
    593:         }
    594:
    595:         $selectCriteria = new Criteria(CustomerTitlePeer::DATABASE_NAME);
    596:
    597:         if ($values instanceof Criteria) {
    598:             $criteria = clone $values; // rename for clarity
    599:
    600:             $comparison = $criteria->getComparison(CustomerTitlePeer::ID);
    601:             $value = $criteria->remove(CustomerTitlePeer::ID);
    602:             if ($value) {
    603:                 $selectCriteria->add(CustomerTitlePeer::ID, $value, $comparison);
    604:             } else {
    605:                 $selectCriteria->setPrimaryTableName(CustomerTitlePeer::TABLE_NAME);
    606:             }
    607:
    608:         } else { // $values is CustomerTitle object
    609:             $criteria = $values->buildCriteria(); // gets full criteria
    610:             $selectCriteria = $values->buildPkeyCriteria(); // gets criteria w/ primary key(s)
    611:         }
    612:
    613:         // set the correct dbName
    614:         $criteria->setDbName(CustomerTitlePeer::DATABASE_NAME);
    615:
    616:         return BasePeer::doUpdate($selectCriteria, $criteria, $con);
    617:     }
    618:
    619:     /**
    620:      * Deletes all rows from the customer_title table.
    621:      *
    622:      * @param      PropelPDO $con the connection to use
    623:      * @return int             The number of affected rows (if supported by underlying database driver).
    624:      * @throws PropelException
    625:      */
    626:     public static function doDeleteAll(PropelPDO $con = null)
    627:     {
    628:         if ($con === null) {
    629:             $con = Propel::getConnection(CustomerTitlePeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
    630:         }
    631:         $affectedRows = 0; // initialize var to track total num of affected rows
    632:         try {
    633:             // use transaction because $criteria could contain info
    634:             // for more than one table or we could emulating ON DELETE CASCADE, etc.
    635:             $con->beginTransaction();
    636:             $affectedRows += BasePeer::doDeleteAll(CustomerTitlePeer::TABLE_NAME, $con, CustomerTitlePeer::DATABASE_NAME);
    637:             // Because this db requires some delete cascade/set null emulation, we have to
    638:             // clear the cached instance *after* the emulation has happened (since
    639:             // instances get re-added by the select statement contained therein).
    640:             CustomerTitlePeer::clearInstancePool();
    641:             CustomerTitlePeer::clearRelatedInstancePool();
    642:             $con->commit();
    643:
    644:             return $affectedRows;
    645:         } catch (PropelException $e) {
    646:             $con->rollBack();
    647:             throw $e;
    648:         }
    649:     }
    650:
    651:     /**
    652:      * Performs a DELETE on the database, given a CustomerTitle or Criteria object OR a primary key value.
    653:      *
    654:      * @param      mixed $values Criteria or CustomerTitle object or primary key or array of primary keys
    655:      *              which is used to create the DELETE statement
    656:      * @param      PropelPDO $con the connection to use
    657:      * @return int The number of affected rows (if supported by underlying database driver).  This includes CASCADE-related rows
    658:      *              if supported by native driver or if emulated using Propel.
    659:      * @throws PropelException Any exceptions caught during processing will be
    660:      *       rethrown wrapped into a PropelException.
    661:      */
    662:      public static function doDelete($values, PropelPDO $con = null)
    663:      {
    664:         if ($con === null) {
    665:             $con = Propel::getConnection(CustomerTitlePeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
    666:         }
    667:
    668:         if ($values instanceof Criteria) {
    669:             // invalidate the cache for all objects of this type, since we have no
    670:             // way of knowing (without running a query) what objects should be invalidated
    671:             // from the cache based on this Criteria.
    672:             CustomerTitlePeer::clearInstancePool();
    673:             // rename for clarity
    674:             $criteria = clone $values;
    675:         } elseif ($values instanceof CustomerTitle) { // it's a model object
    676:             // invalidate the cache for this single object
    677:             CustomerTitlePeer::removeInstanceFromPool($values);
    678:             // create criteria based on pk values
    679:             $criteria = $values->buildPkeyCriteria();
    680:         } else { // it's a primary key, or an array of pks
    681:             $criteria = new Criteria(CustomerTitlePeer::DATABASE_NAME);
    682:             $criteria->add(CustomerTitlePeer::ID, (array) $values, Criteria::IN);
    683:             // invalidate the cache for this object(s)
    684:             foreach ((array) $values as $singleval) {
    685:                 CustomerTitlePeer::removeInstanceFromPool($singleval);
    686:             }
    687:         }
    688:
    689:         // Set the correct dbName
    690:         $criteria->setDbName(CustomerTitlePeer::DATABASE_NAME);
    691:
    692:         $affectedRows = 0; // initialize var to track total num of affected rows
    693:
    694:         try {
    695:             // use transaction because $criteria could contain info
    696:             // for more than one table or we could emulating ON DELETE CASCADE, etc.
    697:             $con->beginTransaction();
    698:
    699:             $affectedRows += BasePeer::doDelete($criteria, $con);
    700:             CustomerTitlePeer::clearRelatedInstancePool();
    701:             $con->commit();
    702:
    703:             return $affectedRows;
    704:         } catch (PropelException $e) {
    705:             $con->rollBack();
    706:             throw $e;
    707:         }
    708:     }
    709:
    710:     /**
    711:      * Validates all modified columns of given CustomerTitle object.
    712:      * If parameter $columns is either a single column name or an array of column names
    713:      * than only those columns are validated.
    714:      *
    715:      * NOTICE: This does not apply to primary or foreign keys for now.
    716:      *
    717:      * @param      CustomerTitle $obj The object to validate.
    718:      * @param      mixed $cols Column name or array of column names.
    719:      *
    720:      * @return mixed TRUE if all columns are valid or the error message of the first invalid column.
    721:      */
    722:     public static function doValidate($obj, $cols = null)
    723:     {
    724:         $columns = array();
    725:
    726:         if ($cols) {
    727:             $dbMap = Propel::getDatabaseMap(CustomerTitlePeer::DATABASE_NAME);
    728:             $tableMap = $dbMap->getTable(CustomerTitlePeer::TABLE_NAME);
    729:
    730:             if (! is_array($cols)) {
    731:                 $cols = array($cols);
    732:             }
    733:
    734:             foreach ($cols as $colName) {
    735:                 if ($tableMap->hasColumn($colName)) {
    736:                     $get = 'get' . $tableMap->getColumn($colName)->getPhpName();
    737:                     $columns[$colName] = $obj->$get();
    738:                 }
    739:             }
    740:         } else {
    741:
    742:         }
    743:
    744:         return BasePeer::doValidate(CustomerTitlePeer::DATABASE_NAME, CustomerTitlePeer::TABLE_NAME, $columns);
    745:     }
    746:
    747:     /**
    748:      * Retrieve a single object by pkey.
    749:      *
    750:      * @param      int $pk the primary key.
    751:      * @param      PropelPDO $con the connection to use
    752:      * @return CustomerTitle
    753:      */
    754:     public static function retrieveByPK($pk, PropelPDO $con = null)
    755:     {
    756:
    757:         if (null !== ($obj = CustomerTitlePeer::getInstanceFromPool((string) $pk))) {
    758:             return $obj;
    759:         }
    760:
    761:         if ($con === null) {
    762:             $con = Propel::getConnection(CustomerTitlePeer::DATABASE_NAME, Propel::CONNECTION_READ);
    763:         }
    764:
    765:         $criteria = new Criteria(CustomerTitlePeer::DATABASE_NAME);
    766:         $criteria->add(CustomerTitlePeer::ID, $pk);
    767:
    768:         $v = CustomerTitlePeer::doSelect($criteria, $con);
    769:
    770:         return !empty($v) > 0 ? $v[0] : null;
    771:     }
    772:
    773:     /**
    774:      * Retrieve multiple objects by pkey.
    775:      *
    776:      * @param      array $pks List of primary keys
    777:      * @param      PropelPDO $con the connection to use
    778:      * @return CustomerTitle[]
    779:      * @throws PropelException Any exceptions caught during processing will be
    780:      *       rethrown wrapped into a PropelException.
    781:      */
    782:     public static function retrieveByPKs($pks, PropelPDO $con = null)
    783:     {
    784:         if ($con === null) {
    785:             $con = Propel::getConnection(CustomerTitlePeer::DATABASE_NAME, Propel::CONNECTION_READ);
    786:         }
    787:
    788:         $objs = null;
    789:         if (empty($pks)) {
    790:             $objs = array();
    791:         } else {
    792:             $criteria = new Criteria(CustomerTitlePeer::DATABASE_NAME);
    793:             $criteria->add(CustomerTitlePeer::ID, $pks, Criteria::IN);
    794:             $objs = CustomerTitlePeer::doSelect($criteria, $con);
    795:         }
    796:
    797:         return $objs;
    798:     }
    799:
    800: } // BaseCustomerTitlePeer
    801:
    802: // This is the static code needed to register the TableMap for this table with the main Propel class.
    803: //
    804: BaseCustomerTitlePeer::buildTableMap();
    805:
    806: